#include "sphere.h"

/*
 *  Check if the ray hits the Sphere at positive t less than current value of t
 */
bool Sphere::hit(Ray& r)
{
   Vec3 dist = pos - r.org;
   double B = r.dir*dist;
   double D = B*B - dist*dist + size*size;
   if (D<0) return false;
   double t0 = B - sqrt(D);
   double t1 = B + sqrt(D);
   if (t0>0.1 && t0<r.t)
   {
      r.t = t0;
      return true;
   }
   else if (t1>0.1 && t1<r.t)
   {
      r.t = t1;
      return true;
   }
   else
      return false;
}
